﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace ParticleSim
{
    class Sprite
    {
        public Texture2D texture = Simulator.texture;
        public Color color = Color.White;
        public Rectangle source = new Rectangle(0, 0, 128, 128);
        public Color[] colors = new Color[16384];

        public Sprite()
        {
            texture = new Texture2D(Program.simulator.GraphicsDevice, 128, 128);
            //texture = Texture2D.FromStream(Program.simulator.GraphicsDevice, Simulator.textureStream);
            //texture = Simulator.texture;
            for (int i = 0; i < 16384; i++)
            {
                colors[i].R = 20;
                colors[i].G = 20;
                colors[i].B = 20;
                colors[i].A = 255;
            }
            texture.SetData<Color>(colors);
        }

        public void SetColor(Color color)
        {
            this.color = color;
        }

        public void SetColor(int r, int g, int b)
        {
            color.R = (byte) r;
            color.G = (byte) g;
            color.B = (byte) b;
        }

        public void SetColorRandom()
        {
            SetColor(Simulator.random.Next(255), Simulator.random.Next(255), Simulator.random.Next(255));
        }

        public void SetRandomPixelColor()
        {
            Color[] data = new Color[128 * 128];
            texture.GetData(data);
            int i = Simulator.random.Next(128 * 128);
            data[i].R = (byte)Simulator.random.Next(255);
            data[i].G = (byte)Simulator.random.Next(255);
            data[i].B = (byte)Simulator.random.Next(255);
            texture.SetData<Color>(data);
        }
    }
}
